;*****************************************************
;; BTRIMVX232S.lsp < DXFIN  >
;; 2023/05/02
;; for BricCAD V19.2
;; copyright(c) 2008 .. 2023 f.izawa
;*****************************************************

(vl-load-com)
;; DXFRUN.exe Ă΂ubN}iubÑtl[AtOAp[WtOj
(defun ifs_dxfIn_exp (dxfName expFlag purgeFlag / ifs_error attreq elast elast2 blkname ent)
  (defun ifs_error(msg)
    (princ msg)
    (command "_UNDO" "END")
    (setvar "ATTREQ" attreq)
    (setvar "CMDECHO" 1)
    (princ)
  )
  (setq *error* ifs_error)
  (setq attreq (getvar "ATTREQ"))
  (setvar "ATTREQ" 0)
  (setvar "CMDECHO" 0)
  (prompt "\n}w [ESC:I] : ")
  (setq elast (entlast))
  (command "_UNDO" "BE")
  (command "-INSERT" dxfname "S" 1 "R" 0)
  (while (wcmatch (getvar "CMDNAMES") "*INSERT")
    (command pause)
  )    
  (setq elast2 (entlast))
  (if (and expFlag (not (equal elast elast2)))
    (progn
      (setq ent (entget elast2))
      (if (= "INSERT" (cdr (assoc 0 ent)))
        (progn
          (command "_EXPLODE" elast2 ) ;; 2023/05/02 Ō "" 폜
          (if purgeFlag
            (progn
              (setq blkname (cdr (assoc 2 ent)))
              (command "_PURGE" "B" blkname "N")
            )
          )
        )
      )        
    )
  )
  (command "_UNDO" "END")
  (setvar "ATTREQ" attreq)
  (setvar "CMDECHO" 1)
  (setq *error* nil)
  (princ)
)

;; DXFRUN.exe Ă΂ubN}iubÑtl[AJbgtOAJԂtOj
(defun ifs_dxfIn_cut (dxfName cut rep / ifs_error attreq elast elast2 loop)
  (defun ifs_error(msg)
    (princ msg)
    (command "_UNDO" "END")
    (setvar "ATTREQ" attreq)
    (setvar "CMDECHO" 1)
    (princ)
  )
  (setq *error* ifs_error)
  (setq attreq (getvar "ATTREQ"))
  (setvar "ATTREQ" 0)
  (setvar "CMDECHO" 0)
  (setq loop T)
  (while loop
    (prompt "\n}w [ESC:I] : ")
    (setq elast (entlast))
    (command "_UNDO" "BE")
    (command "-INSERT" dxfname "S" 1 "R" 0)
    (while (wcmatch (getvar "CMDNAMES") "*INSERT")
      (command pause)
    )    
    (setq elast2 (entlast))
    (if (and cut (not (equal elast elast2)))
      (progn
        (ifs_sub_btrimvx elast2)
        (if (ifs_getAttValue elast2 "NAME")
          (progn
            (ifs_layerOn "NAME")
            (ifs_sub_nmed elast2 nil)
          )
        )
      )
    )
    (setq loop rep)
  )
  (command "_UNDO" "END")
  (setvar "ATTREQ" attreq)
  (setvar "CMDECHO" 1)
  (setq *error* nil)
  (princ)
)

;; ύX
;; ꍇ nil Ԃ
(defun ifs_setAttValue(blkEname tagName tagValue / ename ent tag value res loop)
	(setq 
		ename blkename ent (entget ename)
		loop (and (= (cdr (assoc 0 ent)) "INSERT") (assoc 66 ent) (= 1 (cdr (assoc 66 ent))))
	)
	(while (and loop (/= "SEQEND" (cdr (assoc 0 (entget (setq ename (entnext ename)))))))
		(setq ent (entget ename) tag (cdr (assoc 2 ent)) value (cdr (assoc 1 ent)))
	 	(if (= tagName tag)
			(progn
				(entmod (subst (cons 1 tagvalue)(assoc 1 ent) ent))
		 		(setq loop nil res T)
			)
		)
	)
	res
)

;; ǂݏo
;; ꍇ nil Ԃ
(defun ifs_getAttValue(blkEname tagName / ename ent tag value res loop)
	(setq 
    ename blkename ent (entget ename)
		loop (and (= (cdr (assoc 0 ent)) "INSERT") (assoc 66 ent) (= 1 (cdr (assoc 66 ent))))
	)
	(while (and loop (/= "SEQEND" (cdr (assoc 0 (entget (setq ename (entnext ename)))))))
		(setq ent (entget ename) tag (cdr (assoc 2 ent)) value (cdr (assoc 1 ent)))
	 	(if (= tagName tag)
		 	(setq loop nil res value)
		)
	)
	res
)


;; ǂݏoAύX
;; value = nil : ǂݏô
;; ߂l nil = tagName Ȃ
(defun ifs_attval (entName tagName value / loop ent ename tag val res) 
  (setq 
    ename entName ent (entget ename)
    loop (and (= (cdr (assoc 0 ent)) "INSERT") (assoc 66 ent) (= 1 (cdr (assoc 66 ent))))
  )
  (while 
    (and loop (/= "SEQEND" (cdr (assoc 0 (entget (setq ename (entnext ename)))))))
    (setq ent (entget ename) tag (cdr (assoc 2 ent)) val (cdr (assoc 1 ent)))
    (if (= tagName tag) 
      (progn 
        ;; lύX
        (if value (entmod (subst (cons 1 value) (assoc 1 ent) ent)))
        (setq res  val loop nil)
      )
    )
  )
  res
)

;; ǂݏoAύX(2)
;;  value = nil : ǂݏô
;; ex : (setq lst (ifs_attval2 ename "NAME" "NAME1" nil nil))
;;  value =  : XV
;; ex : (ifs_attval2 ename "NAME" "NAME1" "TEST" "")
;; ߂l nil = tagName Ȃ
(defun ifs_attval2 (entName tagName1 tagName2 value1 value2 / loop ent ename tag val 
                    res1 res2 cnt) 
  (setq 
    ename entName ent (entget ename)
    loop  (and (= (cdr (assoc 0 ent)) "INSERT")(assoc 66 ent)(= 1 (cdr (assoc 66 ent))))
  )
  (setq cnt 0)
  (while 
    (and loop (/= "SEQEND" (cdr (assoc 0 (entget (setq ename (entnext ename)))))))
    (setq ent (entget ename) tag (cdr (assoc 2 ent)) val (cdr (assoc 1 ent)))
    (if (= tagName1 tag) 
      (progn  ;; lύX
        (if value1 (entmod (subst (cons 1 value1) (assoc 1 ent) ent)))
        (setq res1 val cnt (1+ cnt))
      )
      (if (= tagName2 tag) 
        (progn  ;; lύX
          (if value2 (entmod (subst (cons 1 value2) (assoc 1 ent) ent)))
          (setq res2 val cnt  (1+ cnt))
        )
      )
    )
    (setq loop (< cnt 2))
  )
  (list res1 res2)
)

;; @햼XV
(defun ifs_func_edit_bname (ename layerCheck / txt0 txt1 res ret stra strb ent) 
  (if layerCheck 
    (if (setq ent (tblsearch "LAYER" "NAME")) 
      (if (/= (cdr (assoc 70 ent)) 0) 
        (command "_-LAYER" "T" "NAME" "U" "NAME" "")
      )
    )
  )
  (setq res  (ifs_attval2 ename "NAME" "NAME1" nil nil)
        txt0 (car res)
        txt1 (cadr res)
        ret  (or txt0 txt1)
  )
  (if (and txt0 (not txt1)) 
    (progn 
      (setq stra (getstring (strcat "\nV@햼 (= . ) < " txt0 " > : ")))
      (cond 
        ((= stra ".")
          (ifs_setAttvalue ename "NAME" ""))
        ((/= stra "") 
          (ifs_setAttvalue ename "NAME" (strcase stra)))
      )
    )
  )
  (if (and txt0 txt1) 
    (progn 
      (setq stra (getstring (strcat "\nV@햼 1 sڂ (= . ) < " txt0 " > : ")))
      (cond 
        ((= stra ".") 
          (ifs_setAttvalue ename "NAME" ""))
        ((/= stra "") 
          (ifs_setAttvalue ename "NAME" (strcase stra)))
      )
      (setq strb (getstring (strcat "\n@햼 2 sڂ (= . ) < " txt1 " > : ")))
      (cond 
        ((= strb ".") 
          (ifs_setAttvalue ename "NAME1" ""))
        ((/= strb "") 
          (ifs_setAttvalue ename "NAME1" (strcase strb)))
      )
    )
  )
  ;; @햼 nil
  ret
)

;;ubN̎͂̐
(defun ifs_sub_bjointvx (ename / ent maxpt minpt ss temp) 
  (setq ent (entget ename))
  (if (= (cdr (assoc 0 ent)) "INSERT") 
    (progn 
      (setq temp  (ifs_getBoundingBox ename)
            temp  (ifs_lineW (car temp) (cadr temp) (* 0.1 (getvar "DIMSCALE")))
            minpt (car temp)
            maxpt (cadr temp)
      )
      ;;(command "RECTANG" "_none" minpt "_none" maxpt)
      ;;ubN̎͂̐}`擾
      (if (and (setq ss (ssget "C" minpt maxpt '((0 . "LINE")))) 
               (> (sslength ss) 0))
        (ifs_lineJoint ss (cdr (assoc 10 ent)) minpt maxpt) ;; ڑ
      )
    )
  )
)

;; ubŇJbg
;; ubN𕪉B̐}`ubNƂȊOɕ
(defun ifs_vla-Explode ( blkobj / obj lst explst blklst)
  (if (= (vla-get-ObjectName blkobj) "AcDbBlockReference")
    (progn
      (setq lst (vlax-safearray->list (vlax-variant-value (vla-Explode blkobj ))))
      (foreach obj lst
        (if (= (vla-get-ObjectName obj) "AcDbBlockReference")
          (setq blklst (append blklst (list obj)))
          (setq explst (append explst (list obj)))
        )  
      )
    )
  )
  (list blklst explst)
)

(defun ifs_func_blkExplode ( topobj / blk blklst dellst explst item loop temp temp_blklst )
  (if  (= (vla-get-ObjectName topobj) "AcDbBlockReference")
    (setq blklst (list topobj) loop T)   
  )
  (while loop
    (setq temp_blklst nil)
    (foreach blk blklst
      (setq temp (ifs_vla-Explode blk));; 
      (if (car temp)
        (foreach item (car temp)
          (setq temp_blklst (append temp_blklst (list item)))
          (if (not (equal item topobj))
            (setq dellst (append dellst (list item)));; ς̃ubN
          )
        )
        (setq loop nil)
      )
      (if (cadr temp)
        (foreach item (cadr temp)
          (setq explst (append explst (list item)));; ꂽ}`
        )
      )
    )
    (setq blklst temp_blklst)
  )
  (list explst dellst)
)

;; ubŇJbg
(defun ifs_sub_btrimvx (ename / ary breaklist i item j lst maxpt minpt obj objname 
                        osm sary ss temp vlaobj vpt xxlst edp ent p1 p2 stp ved vst 
                        pts kp layname lay adoc jogai dimsc dellst explst
                       ) 
  (setq jogai "*KOUTEN*,*CMARK*");; OubN
  (setq breaklist nil
        dimsc     (getvar "DIMSCALE")
  )
  (setq vlaobj (vlax-ename->vla-object ename))
  (if (and (= (vla-get-ObjectName vlaobj) "AcDbBlockReference") 
           (not (wcmatch (vla-get-name vlaobj) jogai)))
    (progn 
      (setq temp  (ifs_getBoundingBox ename)
            temp  (ifs_lineW (car temp) (cadr temp) (* 0.1 dimsc))
            minpt (car temp)
            maxpt (cadr temp)
      )
      ;;ubN̎͂̐}`擾
      (if (and (setq ss (ssget "C" minpt maxpt '((0 . "LINE")))) 
               (> (sslength ss) 0))
        (progn 
          ;;̐}`Xg
          ;; Z l 0 łȂ͌Ȃ̂Ō_ƂȂ
          ;; lXgꂽubNɑΉ
          (setq lst (ifs_func_blkExplode vlaobj))
          (setq explst (car lst) dellst (cadr lst))
          
          (setq i 0)
          (repeat (sslength ss) 
            (setq obj (vlax-ename->vla-object (ssname ss i)))
            (setq xxlst nil)
            (foreach item explst 
              ;; }`̖́@ w̃`FbNǉ
              (setq objname (vla-get-ObjectName item)
                    layname (vla-get-layer item)
                    adoc    (vla-get-activedocument (vlax-get-Acad-Object))
                    lay (vla-item (vla-get-layers adoc) layname)
              )
              ;; C
              (if (not (and (= :VLAX-TRUE (vla-get-layeron lay)) 
                            (= :VLAX-FALSE (vla-get-freeze lay)))) 
                (setq objname "")
              )
              (if (wcmatch objname "AcDbLine,AcDbCircle,AcDbArc,AcDbPolyline")
                (progn 
                  ;;}`m̌_𓾂
                  (setq vpt (vla-intersectwith obj item acExtendThisEntity))
                  (if (and vpt (listp vpt))  ;;Xgł邩
                    (progn  ;;for LT-Extender
                           (setq j 0)
                           (repeat (/ (length vpt) 3) 
                             (setq xxlst (cons (list (nth (* j 3) vpt)(nth (+ (* j 3) 1) vpt)(nth (+ (* j 3) 2) vpt)) xxlst))
                             (setq j (1+ j))
                           )
                    )
                    (if vpt 
                      (progn
                        (setq sary (vlax-variant-value vpt))
                        ;; ubNƂ̌_
                        (if (>= (vlax-safearray-get-u-bound sary 1) 2) 
                          (progn 
                            ;;SzLISPW
                            (setq ary (vlax-safearray->list sary))
                            (setq j 0)
                            (repeat (/ (length ary) 3) 
                              (setq xxlst (cons (list (nth (* j 3) ary)(nth (+ (* j 3) 1) ary)(nth (+ (* j 3) 2) ary)) xxlst))
                              (setq j (1+ j))
                            )
                          )
                        )
                      )
                    )
                  )
                  ;;꒼̐̎́A̒[__Ƃč̗p
                  (if (= objname "AcDbLine") 
                    (progn 
                      (setq vst (vla-get-startpoint item)
                            ved (vla-get-endpoint item)
                            stp (vlax-safearray->list (vlax-variant-value vst))
                            edp (vlax-safearray->list (vlax-variant-value ved))
                            ent (entget (ssname ss i))
                            p1  (cdr (assoc 10 ent))
                            p2  (cdr (assoc 11 ent))
                      )
                      (if (ifs_is_douitu p1 p2 stp edp) 
                        (setq xxlst (cons stp xxlst)
                              xxlst (cons edp xxlst)
                        )
                      )
                    )
                  )
                )
              )
            )
            (if (not xxlst) 
              (progn  ;; IntersectWith Ō_Ȃ = Z <> 0.0
                     ;;  ubN̋`͈͂Ƃ̌_
                     (setq ent (entget (ssname ss i))
                           p1  (cdr (assoc 10 ent))
                           p2  (cdr (assoc 11 ent))
                     )
                     (setq pts (list minpt 
                                     (list (car minpt) (cadr maxpt) 0.0)
                                     maxpt
                                     (list (car maxpt) (cadr minpt) 0.0)
                                     minpt
                               )
                     )
                     (setq j 0)
                     (repeat (1- (length pts)) 
                       (if (setq kp (inters p1 p2 (nth j pts) (nth (1+ j) pts))) 
                         (setq xxlst (cons kp xxlst))
                       )
                       (setq j (1+ j))
                     )
              )
            )
            ;;_Xg}`Ƌɕێ
            (if (and xxlst (= (length xxlst) 1))  ;; _ 1 
              (if (ifs_inWindow p1 minPt maxPt) 
                (setq xxlst (cons p1 xxlst))
                (if (ifs_inWindow p2 minPt maxPt) 
                  (setq xxlst (cons p2 xxlst))
                )
              )
            )
            (if xxlst 
              (setq breaklist (cons (list (ssname ss i) xxlst) breaklist))
            )
            (setq i (1+ i))
          )
          ;;ꂽIuWFNg폜
          (if explst
            (foreach item explst 
              (vla-Delete item)
            )
          )
          ;; ς̃ubN폜
          (if dellst
            (foreach item dellst 
              (vla-Delete item)
            )
          )
          
          ;;Ƃɕ폜
          (setq osm (getvar "OSMODE"))
          (setvar "OSMODE" 0)
          (setvar "CMDECHO" 0)
          (foreach item breaklist 
            (if (>= (length (cadr item)) 2)
              (progn 
                (setq temp (ifs_get_max_pos (cadr item)))
                (command "_break" (car item) "none" (car temp) "none" (cadr temp))
                ;; _̏ꍇ̏lEEE
              )
            )
          )
          (setvar "OSMODE" osm)
        )
      )
    )
  )
)

;; _ pt ` minpt-maxpt ͈͓ɂ邩
(defun ifs_inWindow (pt minPt maxPt) 
  (and (>= (car pt) (car minPt)) 
       (<= (car pt) (car maxPt))
       (>= (cadr pt) (cadr minPt))
       (<= (cadr pt) (cadr maxPt))
  )
)

;; ubN̐}`𐧌āA`̈𓾂
(defun ifs_getBoundingBox (ename / objNames vlaObj objName xLst yLst lst 
                           layName layEnt maxPt minPt minPt2 minVpt2 maxPt2 maxVpt2 
                           res dellst explst item 
                          )
  (setq objNames "AcDbArc,AcDbLine,AcDbCircle,AcDbPolyline"
        vlaObj   (vlax-ename->vla-object ename)
        objName  (vla-get-ObjectName vlaObj)
  )
  (if (= objName "AcDbBlockReference") 
    (progn 
      (setq lst (ifs_func_blkExplode vlaobj))
      (setq explst (car lst) dellst (cadr lst))
      (foreach vlaObj explst 
        (if (wcmatch (vla-get-ObjectName vlaObj) objNames) 
          (progn 
            (setq layName (vla-get-layer vlaObj)
                  layEnt  (tblsearch "Layer" layName)
            )
            (if (= (cdr (assoc 70 layEnt)) 0);;70 = t[Y/bNĂȂ
              (progn 
                ;; `͈͂擾
                (vla-getboundingbox vlaObj 'minVpt2 'maxVpt2)
                (setq minPt2 (vlax-safearray->list minVpt2)
                      maxPt2 (vlax-safearray->list maxVpt2) ;;  XAY WXg
                      xLst   (append xLst (list (car minPt2) (car maxPt2)))
                      yLst   (append yLst (list (cadr minPt2) (cadr maxPt2)))
                )
              )
            )
          )
        )
      )
      ;; ꂽIuWFNg폜
      (if explst
        (foreach item explst 
          (vla-Delete item)
        )
      )
      ;; ς̃ubN폜
      (if dellst
        (foreach item dellst 
          (vla-Delete item)
        )
      )
      ;; XAY ̍ŏAől擾
      (setq minPt2 (list (apply 'min xLst) (apply 'min yLst) 0)
            maxPt2 (list (apply 'max xLst) (apply 'max yLst) 0)
      )
      (if (not (and (equal minPt minPt2 0.0001) (equal maxPt maxPt2 0.0001))) 
        (setq res T)
      )
    )
  )
  (list minPt2 maxPt2)
)

;; POINTXĝőȂQ_𓾂
;; 2_̂Ƃ͂̂܂ܕԂ
(defun ifs_get_max_pos (plist / cnt i j posa posb dist) 
  (setq cnt  (length plist)
        i    0
        posa nil
        posb nil
        dist 0.0
  )
  (if (> cnt 2) 
    (progn 
      (repeat cnt 
        (setq j (+ i 1))
        (repeat (- cnt i 1) 
          (if (> (distance (nth i plist) (nth j plist)) dist) 
            (setq dist (distance (nth i plist) (nth j plist))
                  posa (nth i plist)
                  posb (nth j plist)
            )
          )
          (setq j (1+ j))
        )
        (setq i (1+ i))
      )
    )
    (setq posa (car plist) posb (cadr plist))
  )
  (if (and posa posb) 
    (list posa posb)
    nil
  )
)

;; ꒼̔f
(defun ifs_is_douitu (p1 p2 p3 p4 / res kaku p1 p2 p3 p4 lg1 lg2) 
  (setq kaku (angle p1 p2)
        lg1  (* (distance p1 p3) (sin (- kaku (angle p1 p3))))
  )
  (if (equal 0 lg1 0.001) 
    (setq lg2 (* (distance p1 p4) (sin (- kaku (angle p1 p4))))
          res (equal 0 lg2 0.001)
    )
  )
  res
)

;; WindowQ_
;;  min-max ͖̏Ȃ
;; min-max -ȄŕԂ
(defun ifs_lineW (pt1 pt2 off / p1 p2 off2) 
  (setq off2 (* off (sqrt 2.0)))
  (if (= (length pt1) 3) 
    (setq p1 (list (min (car pt1) (car pt2)) 
                   (min (cadr pt1) (cadr pt2))
                   (caddr pt1)
             )
          p2 (list (max (car pt1) (car pt2)) 
                   (max (cadr pt1) (cadr pt2))
                   (caddr pt1)
             )
    )
    (setq p1 (list (min (car pt1) (car pt2)) (min (cadr pt1) (cadr pt2)))
          p2 (list (max (car pt1) (car pt2)) (max (cadr pt1) (cadr pt2)))
    )
  )
  (list 
    (polar p1 (* Pi 1.25) off2) ;; 
    (polar p2 (* Pi 0.25) off2) ;; E
  )
)

;; pt 1_͂ 2	_issget "W", "C" pj
(defun ifs_pointW (pt off /) 
  (list 
    (list (- (car pt) off) (- (cadr pt) off) 0.0)
    (list (+ (car pt) off) (+ (cadr pt) off) 0.0)
  )
)

;; wIAt[Y
(defun ifs_layerOn( layerName / adoc ent lay lays )
  (if (setq ent (tblsearch "Layer" layerName))
    (if (/= (cdr (assoc 70 ent)) 0)
      (progn
        (setq adoc (vla-get-activedocument (vlax-get-Acad-Object))
              lays (vla-get-layers adoc)
              lay (vla-item lays layerName)
        )
        (if (= :vlax-false (vla-get-layeron lay))
          (vla-put-layeron lay :vlax-true)
        )   
        (if (= :vlax-true (vla-get-freeze lay))
          (vla-put-freeze lay :vlax-false )
        )
      )
    )
  )
)

;; @햼ҏW
(defun ifs_sub_nmed( enameorg org / ent lst org name name1 typ mes str n ss i len s1 s2 
                           kw s new elst1 cnt1 elst2 cnt2 ret ename res)
  (setq res "")
	(setq ent (entget enameorg))
	(if (= "INSERT" (cdr (assoc 0 ent)))
		(progn
			(setq lst (ifs_attval2 enameorg "NAME" "NAME1" nil nil))
			(if (and (car lst)(cadr lst))
				(setq name (car lst) name1 (cadr lst) typ 2);; NAME, NAME1 
				(if (car lst)(setq name (car lst) name1 "" typ 1));;NAME ̂ݑ
			)
		)
	)
	(if (and name name1)
		(progn
      (if (not org)
        (setq org (strcase (strcat name name1)))
      )
      ;;(princ "\norg=")(princ org)
      (if (= typ 2)
        (setq s (strcat name "^" name1))
        (setq s org)
      )
			(setq mes (strcat "\nV@햼( ^ 2s\A . = ) < " s " > : "))
			(setq str (strcase (getstring T mes)))
      (if (= str "")(setq str s))
      ;;(princ str)
      (if (/= str "")
				(progn
					(if (= "." str)(setq str ""))
          (if (> (setq n (ifs_strpos	"^" str)) 0)
            (setq name  (substr str 1 (1- n))
						      name1 (substr str (1+ n) (- (strlen str) n))
            )
            (setq name str name1 "")
          )
          (setq new (strcat name name1))
          (setq cnt1 0 cnt2 0)
          ;; Ő@햼ύX(OO)
          (if (and (/= org new) (setq ss (ssget "X" '((0 . "INSERT")))));;
            (progn
              (setq len (sslength ss) i 0)
              (repeat len
                (setq ename (ssname ss i)
                      s1 (ifs_getAttValue ename "NAME" )
                      s2 (ifs_getAttValue ename "NAME1")
                )
                (if s1 (setq s1 (strcase s1)))
                (if s2 (setq s2 (strcase s2)))
                (if (and (/= org "")(/= org "^"))
                  (if (or (and s1 s2 (= (strcat s1 s2) org)) (and s1 (= s1 org)))
                    (setq cnt1 (1+ cnt1) elst1 (append elst1 (list ename)))
                  )
                )
                (if (or (and s1 s2 (= (strcat s1 s2) new)) (and s1 (= s1 new)))
                  (setq cnt2 (1+ cnt2) elst2 (append elst2 (list ename)))
                )               
                (setq i (1+ i))
              )
              (setq ret nil)
              (if (and (/= new "")(> cnt2 0))
                (progn
                  (initget "Yes No")
                  (setq kw (getkword 
                    (strcat "\nV@햼 " new " Ɠ@햼 " (itoa cnt2) " ܂Ds܂HuYes /No] < Yes > : "))
                  )
                  (setq ret (/= kw "No"))
                )
                (setq ret T)
              )
              (if ret
                (progn
                  (command "_UNDO" "BE")
                  (if (= typ 2)
                    (ifs_attval2 enameorg "NAME" "NAME1" name name1)
                    (ifs_attval  enameorg "NAME" (strcat name name1))
                  )
                  (command "_UNDO" "END")
                  (setq res str);; ͕Ԃ
                )
              )
              (if (/= org "")(setq kw "Yes"))
              (if (and ret (> cnt1 1)(/= org ""))
                (progn
                  (initget "Yes No")
                  ;; 
                  (if (not (getkword 
                        (strcat "\n̋@햼 " org " Ɠ@햼 " (itoa (1- cnt1)) " ܂DXV܂HuYes /No] < Yes > : "))
                      )
                    (setq kw "Yes")
                  )
                  (if (and (= kw "Yes") elst1)
                    (progn
                      (command "_UNDO" "BE")
                      (setq i 0)
                      (repeat (length elst1)
                        (setq ename (nth i elst1))
                        (if (not (equal ename enameorg))
                          (progn
                            (setq s1 (ifs_getAttValue ename "NAME" )
                                  s2 (ifs_getAttValue ename "NAME1")
                            )
                            (if (and s1 s2)
                              (ifs_attval2 ename "NAME" "NAME1" name name1)
                              (if s1
                                (ifs_attval ename "NAME" (strcat name name1))
                              )
                            )
                          )
                        )
                        (setq i (1+ i))
                      )
                      (command "_UNDO" "END")
                    )
                  )
                )
              )
            )
          )
				)
			)
		)
	)
  res;; ͂@햼Ԃ
)
(princ "\nBTRIMVX232S.lsp Ver.2023/05/02 DXFIN  : [h܂D")
(princ)
